package com.sun.net.ssl;

import javax.security.cert.X509Certificate;
import java.io.IOException;
import java.net.URL;
import javax.net.ssl.SSLSocketFactory;
import java.net.HttpURLConnection;

@Deprecated
public abstract class HttpsURLConnection extends HttpURLConnection
{
    private static HostnameVerifier defaultHostnameVerifier;
    protected HostnameVerifier hostnameVerifier;
    private static SSLSocketFactory defaultSSLSocketFactory;
    private SSLSocketFactory sslSocketFactory;
    
    public HttpsURLConnection(URL u) throws IOException {
        super(u);
        this.hostnameVerifier = HttpsURLConnection.defaultHostnameVerifier;
        this.sslSocketFactory = getDefaultSSLSocketFactory();
    }
    
    public abstract String getCipherSuite();
    
    public abstract X509Certificate[] getServerCertificateChain();
    
    public static void setDefaultHostnameVerifier(HostnameVerifier defaultHostnameVerifier) {
        if (defaultHostnameVerifier == null) {
            throw new IllegalArgumentException("no default HostnameVerifier specified");
        }
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkPermission(new SSLPermission("setHostnameVerifier"));
        }
        HttpsURLConnection.defaultHostnameVerifier = defaultHostnameVerifier;
        return;
    }
    
    public static HostnameVerifier getDefaultHostnameVerifier() {
        return HttpsURLConnection.defaultHostnameVerifier;
    }
    
    public void setHostnameVerifier(HostnameVerifier hostnameVerifier) {
        if (hostnameVerifier == null) {
            throw new IllegalArgumentException("no HostnameVerifier specified");
        }
        this.hostnameVerifier = hostnameVerifier;
        return;
    }
    
    public HostnameVerifier getHostnameVerifier() {
        return this.hostnameVerifier;
    }
    
    public static void setDefaultSSLSocketFactory(SSLSocketFactory defaultSSLSocketFactory) {
        if (defaultSSLSocketFactory == null) {
            throw new IllegalArgumentException("no default SSLSocketFactory specified");
        }
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkSetFactory();
        }
        HttpsURLConnection.defaultSSLSocketFactory = defaultSSLSocketFactory;
        return;
    }
    
    public static SSLSocketFactory getDefaultSSLSocketFactory() {
        if (HttpsURLConnection.defaultSSLSocketFactory == null) {
            HttpsURLConnection.defaultSSLSocketFactory = (SSLSocketFactory)SSLSocketFactory.getDefault();
        }
        return HttpsURLConnection.defaultSSLSocketFactory;
    }
    
    public void setSSLSocketFactory(SSLSocketFactory sslSocketFactory) {
        if (sslSocketFactory == null) {
            throw new IllegalArgumentException("no SSLSocketFactory specified");
        }
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkSetFactory();
        }
        this.sslSocketFactory = sslSocketFactory;
        return;
    }
    
    public SSLSocketFactory getSSLSocketFactory() {
        return this.sslSocketFactory;
    }
    
    static {
        HttpsURLConnection.defaultHostnameVerifier = new HostnameVerifier() {
            @Override
            public boolean verify(String s, String s2) {
                return false;
            }
        };
        HttpsURLConnection.defaultSSLSocketFactory = null;
    }
}
